# ************************************************************************
# ************* GENERACIÓN DE TABULADOS TOMO II - MATERIAS PRIMAS ********
# ************************************************************************

# ********************************************************************** #
# Instituto Nacional de Estadística y Censos (INEC)                      #
# Fuente: Encuesta Estructural Empresarial 2024                          #
# Responsable: Unidad de Gestión de Estadísticas Estructurales (GESE)    #
# ********************************************************************** #
# Fecha de elaboración: 08/02/2023                                       #
# Fecha última modificación: 04/03/2026                                  #
# ********************************************************************** #
# Elaborado por:                                                         #
# Gestión de Estadísticas Estructurales - GESE                           #
# Instituto Nacional de Estadística y Censos (INEC)                      #
# ********************************************************************** #
# Revisado por:                                                          #
# Roberto Chaves                                                         #
# Jefe de Gestión de Estadísticas Estructurales - GESE                   #
# Instituto Nacional de Estadística y Censos (INEC)                      #
# roberto_chaves@inec.gob.ec                                             #
# ********************************************************************** #
# Aprobado por:                                                          #
# Diana Barco                                                            #
# Directora de Estadísticas Económicas (DECON)                           #
# Instituto Nacional de Estadística y Censos (INEC)                      #
# diana_barco@inec.gob.ec                                                #
##########################################################################

#========================================================================#
# FUNCIONES                                                              #
#========================================================================#

"Carga de librerías"

enesem_lib <- function(libreria) {
  if (!requireNamespace(as.character(libreria), quietly = TRUE)) {
    install.packages(as.character(libreria))
  }
  library(libreria, character.only = TRUE)
}

#========================================================================#
# CARGAR LIBRERÍAS                                                       #
#========================================================================#

enesem_lib("tidyverse")
enesem_lib("lubridate")
enesem_lib("haven")
enesem_lib("openxlsx")
enesem_lib("janitor")

# **** TABULADOS TOMO II - MATERIAS PRIMAS (2024) *** -------------------------------------------------

#Establecer la dirección de trabajo ----

"Estimado Usuario. Por favor en el disco C: de su computadora, crear una carpeta llamada 
Tabulados Tomo II, y coloque la BDD de la encuesta (2024_ENESEM_BDD_Materias_Primas.sav), sintaxis y el
archivo llamado 'DISEÑO_MP.xlsx' contenido en la carpeta Plantillas. 
En esta carpeta se exportarán los resultados de los tabulados."

setwd("C:/Tabulados Tomo II")

#Abrir directorio.
dir()

# *** Llamar base de datos****

dat <- read_sav("2024_ENESEM_BDD_Materias_Primas.sav") #En caso de haber editado el nombre de la BDD reemplazarlo en esta línea

# dat <-  read_csv("2024_ENESEM_BDD_Materias_Primas.csv") #En caso de que se descargue la base de datos en formato csv, quitar comentario (#) de esta línea de código y comentar (#) el comando read_sav.

######### 1) TABULADOS MATERIAS #########

materias_primas <- dat %>% 
  group_by(cod_cpc, desc_cod_cpc,uni_med_desc) %>% 
  summarise(cant_local = sum(cantidad_local, na.rm=TRUE),
            valor_local = sum(valor_local, na.rm=TRUE),
            cantidad_impor = sum(cantidad_impor, na.rm=TRUE),
            valor_impor = sum(valor_impor, na.rm=TRUE),
            cant_terceros = sum(cant_terceros, na.rm=TRUE)) 

suma <- c(colSums(materias_primas[,c(5,7)])) 

materias_primas <- bind_rows(materias_primas, suma) %>% 
  arrange(!is.na(cod_cpc)) %>% 
  rename("CPC Ver. 2.0" = cod_cpc,
         "Descripción" = desc_cod_cpc,
         "Unidad de medida" = uni_med_desc,
         "Cantidad de compras netas locales de materia prima" = cant_local,
         "Valor de compras netas locales de materia prima" = valor_local,
         "Cantidad de importaciones de materia prima" = cantidad_impor,
         "Valor de importaciones de materia prima"= valor_impor,
         "Cantidad para elaboración para cuenta de terceros"= cant_terceros)

materias_primas[1,2] <- "Total Nacional"  

# ============================================================================ #
#####               DISEÑO Y EXPORTACIÓN DE TABULADOS A EXCEL              ##### 
# ============================================================================ #

"En esta sección se diseñará y exportará los tabulados en formato excel"

##### Configuración tabulados #####

mp <- loadWorkbook("DISEÑO_MP.xlsx")

##### CREACIÓN #####

writeData(mp,
          "C1",
          materias_primas, 
          startRow = 3, 
          startCol = 1,  
          colNames = TRUE)

##### EXPORTACIÓN #####

anio_inv <- floor_date(today(), "day") %>%
  str_sub(1, 4) %>% 
  as.numeric() %>% 
  sum(-2, na.rm = T) %>% 
  str_c(.,"_","ENESEM_Tabulados_Materias_Primas.xlsx")

saveWorkbook(mp, anio_inv,overwrite = TRUE)

